import com.jacob.com.Dispatch;
import com.jacob.com.Variant;
import com.jacob.activeX.ActiveXComponent;
import java.util.concurrent.TimeUnit;
import java.util.Scanner;

public class common {
    public static ActiveXComponent comServer;
    private static Scanner scanner = new Scanner(System.in);

    public static void killApp() {
        try {
            ProcessBuilder pb = new ProcessBuilder("cmd.exe", "/c", "taskkill", "/IM", "SQLACC.exe", "/F");
            Process process = pb.start();
            process.waitFor();
            TimeUnit.SECONDS.sleep(2);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void checkLogin() {
        try {
            comServer = new ActiveXComponent("SQLAcc.BizApp");
            Variant isLogin = Dispatch.get(comServer, "IsLogin");

            if (isLogin.getBoolean()) {
                Dispatch.call(comServer, "Logout");
                killApp();
                comServer = new ActiveXComponent("SQLAcc.BizApp");
            }

            try {
                Dispatch.call(comServer, "Login",
                        "ADMIN",
                        "ADMIN",
                        "C:\\eStream\\SQLAccounting\\Share\\Default.DCF",
                        "ACC-0001.FDB");
                System.out.println("Login successful!");
            } catch (Exception e1) {
                try {
                    Dispatch.call(comServer, "login",
                            "ADMIN",
                            "ADMIN",
                            "C:\\eStream\\SQLAccounting\\Share\\Default.DCF",
                            "ACC-0001.FDB");
                } catch (Exception e2) {
                    System.out.println("Login failed: " + e2.getMessage());
                    comServer = null;
                }
            }
        } catch (Exception e) {
            System.out.println("Error initializing COM object: " + e.getMessage());
            e.printStackTrace();
            comServer = null;
        }
    }

    public static void showResult(Dispatch aDataset) {
        try {
            if (aDataset == null) {
                System.out.println("Dataset is null, cannot show results");
                return;
            }

            Variant recordCount = Dispatch.get(aDataset, "RecordCount");
            if (recordCount.getInt() > 0) {
                while (!Dispatch.get(aDataset, "EOF").getBoolean()) {
                    Dispatch fields = Dispatch.get(aDataset, "Fields").toDispatch();
                    int fieldCount = Dispatch.get(fields, "Count").getInt();
                    for (int x = 0; x < fieldCount; x++) {
                        Dispatch field = Dispatch.call(fields, "Items", x).toDispatch();
                        String fieldName = Dispatch.get(field, "FieldName").getString();
                        Dispatch foundField = Dispatch.call(aDataset, "FindField", fieldName).toDispatch();
                        String fieldValue = Dispatch.get(foundField, "AsString").getString();
                        String result = "Index : " + x + " FieldName : " + fieldName + " Value : " + fieldValue;
                        System.out.println(result);
                    }
                    System.out.println("====");
                    Dispatch.call(aDataset, "Next");
                }
            } else {
                System.out.println("Record Not Found");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
        checkLogin();

        if (comServer != null) {
            try {
                String choice = "";

                while (!choice.equalsIgnoreCase("Q")) {
                    System.out.println("\n1. Show Data");
                    System.out.println("2. Post Data");
                    System.out.println("3. Delete Data");
                    System.out.print("Choose an operation (Q to Quit): ");

                    choice = scanner.nextLine();
                    System.out.println();

                    if (choice.equalsIgnoreCase("Q")) {
                        System.out.println("Exiting program...");
                        break;
                    }

                    try {
                        int option = Integer.parseInt(choice);

                        switch (option) {
                            case 1:
                                String sql = "SELECT * FROM AGENT WHERE ISACTIVE = 'True' ORDER BY CODE";
                                Dispatch dbManager = Dispatch.get(comServer, "DBManager").toDispatch();
                                Dispatch dataset = Dispatch.call(dbManager, "NewDataSet", sql).toDispatch();
                                showResult(dataset);
                                break;

                            case 2:
                                postData();
                                break;

                            case 3:
                                delData();
                                break;

                            default:
                                System.out.println("Invalid option. Please try again.");
                                break;
                        }
                    } catch (NumberFormatException e) {
                        System.out.println("Please enter a number or 'Q' to quit.");
                    } catch (Exception e) {
                        System.out.println("Error showing data: " + e);
                    }
                }

                if (comServer != null) {
                    Dispatch.call(comServer, "Logout");
                    killApp();
                }

            } catch (Exception e) {
                System.out.println("Error: " + e.getMessage());
            }
        } else {
            System.out.println("Failed to log in.");
        }
    }

    public static String postData() {
        String action = "";
        try {
            Dispatch bizObject = Dispatch.call(comServer, "BizObjects").toDispatch();
            Dispatch agent = Dispatch.call(bizObject, "Find", "Agent").toDispatch();
            Dispatch mainDataSet = Dispatch.call(Dispatch.get(agent, "DataSets").toDispatch(), "Find", "MainDataSet")
                    .toDispatch();

            Variant docKey = Dispatch.call(agent, "FindKeyByRef", "CODE", "FAIRY");

            if (docKey.isNull()) {
                Dispatch.call(agent, "New");
                Dispatch.put(Dispatch.call(mainDataSet, "FindField", "CODE").toDispatch(), "Value", "FAIRY");
                Dispatch.put(Dispatch.call(mainDataSet, "FindField", "DESCRIPTION").toDispatch(), "Value",
                        "FAIRY TAIL");
                action = "Adding";
            } else {
                Dispatch.put(Dispatch.call(Dispatch.get(agent, "Params").toDispatch(), "Find", "Code").toDispatch(),
                        "Value", docKey);
                Dispatch.call(agent, "Open");
                Dispatch.call(agent, "Edit");
                Dispatch.put(Dispatch.call(mainDataSet, "FindField", "DESCRIPTION").toDispatch(), "Value",
                        "FAIRY TAIL WIZARD");
                action = "Editing";
                System.out.println("Existing record is found");
            }

            try {
                Dispatch.call(agent, "Save");
            } catch (Exception e) {
                System.out.println("Error saving: " + e.getMessage());
            }

            Dispatch.call(agent, "Close");
            System.out.println(action + " done");
        } catch (Exception e) {
            System.out.println("Error in postData: " + e);
            e.printStackTrace();
        }
        return action;
    }

    public static void delData() {
        try {
            Dispatch bizObject = Dispatch.call(comServer, "BizObjects").toDispatch();
            Dispatch agent = Dispatch.call(bizObject, "Find", "Agent").toDispatch();

            Variant docKey = Dispatch.call(agent, "FindKeyByRef", "CODE", "FAIRY");

            if (docKey.isNull()) {
                System.out.println("Record Not Found");
            } else {
                System.out.print("Are you sure you want to delete (Y/N)? ");
                String delAnswer = scanner.nextLine();
                if (delAnswer.toLowerCase().equals("y") || delAnswer.toLowerCase().equals("yes")) {
                    Dispatch.put(Dispatch.call(Dispatch.get(agent, "Params").toDispatch(), "Find", "Code").toDispatch(),
                            "Value", docKey);
                    Dispatch.call(agent, "Open");
                    Dispatch.call(agent, "Delete");
                    System.out.println("Deleting done");
                } else {
                    System.out.println("Deletion cancelled");
                }
            }
        } catch (Exception e) {
            System.out.println("Error in delData: " + e);
            e.printStackTrace();
        }
    }
}